//
//  main.cpp
//  problem 3
//
//  Created by 廖偉宏 on 2016/4/11.
//  Copyright © 2016年 PD2016. All rights reserved.
//

#include <iostream>
using namespace std;

// use the code of the previous problem as a function
void printOfficers(int demand[7], int start);
int main() {
    int demand[7]={0};
    for(int i=0; i<7; i++) {
        cin>>demand[i];
    }
    // print the number of officers needed of the algorithm starting from the day i
    printOfficers(demand, 0);
    for(int i=1; i<7; i++) {
        cout<<" ";
        printOfficers(demand, i);
    }
    cout<<"\n";
    return 0;
}
// the same as the previous problem
// the variable start is the starting index
// to avoid using the memory out of the array, use %7 to make the range of index 0~6
void printOfficers(int originDemand[7], int start) {
    int demand[7];
    for(int i=0; i<7; i++) {
        demand[i]=originDemand[i];
    }
    int officers[7];
    for(int i=start; i<start+7; i++) {
        officers[i%7]=demand[i%7];
        for(int j=0; j<5; j++) {
            demand[(i+j)%7]-=officers[i%7];
            if(demand[(i+j)%7]<0) {
                demand[(i+j)%7]=0;
            }
        }
    }
    // print the sum
    int sum=0;
    for(int i=0; i<7; i++) {
        sum+=officers[i];
    }
    cout<<sum;
}
